//
//  MQSpeextDecoder.h
//  SpeexCodec
//
//  Created by cliftoncraig07 on 3/16/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#include <speex/speex.h>
#include <ogg/ogg.h>

@protocol MySpeexDecoderDelegate <NSObject>

@optional
-(void) willDecodeAudioWithAttributes:(NSDictionary*)attributes;
-(void) audioWasDecoded:(NSData*)rawAudio;

@end

@interface MySpeexDecoder : NSObject {
	ogg_sync_state synchState;
	ogg_page oggPage;
	ogg_stream_state oggStreamState;
	ogg_packet oggPacket;

	SpeexBits bits;
	void *theSpeexDecoder;
	
	NSDictionary* audioAttributes;
	NSInputStream *dataStream;
	BOOL continueToDecode;
	
	id delegate;
	int numberOfDataReadPasses;
}

@property (nonatomic, assign) id delegate;
@property (nonatomic) int numberOfDataReadPasses;
-(void) decodeAudioAtPath:(NSString*)speexAudioPath;
@end
